
/* 
 * ProbView.h -- Interface file for the ProbView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use.
 *
 */

#import <appkit/appkit.h>

@interface ProbView:View {

	id		sButton, pButton;
	id		aSwitch;
	id		dTwig;
	id		gridSize;
	id		wrule;
	id		rbutton,sbutton;
	id		ruleNumber;
	id		pslid;
	id		pswit;

/* trivia Panel    - - - - - - - - - - - - - - - - - - - - - - */

	id		statEnpai;
	id		statEntro;
	id		statIndx;
	id		statLamb;
	id		statLines;
	id		statPair;
	id		statPEntro;
	id		statProd;
	id		statState;
	id		statSDevi;
	id		statNhood;
	id		statXeno;

	id		tiDat;
	id		valBx;

	id		trivEntro;
	id		trivIndx;
	id		trivLamb;
	id		trivPairs;
	id		trivPEntro;
	id		trivProds;
	id		trivState;
	id		trivXeno;

	id		rulePanel;

	id		theBasinView;
	id		theBlockView;
	id		theEntropyView;
	id		theEProbView;
	id		thePlaidView;
	id		theProbView;
	id		theStatView;

	id		basinWindow;
	id		blockWindow;
	id		entropyWindow;
	id		eProbWindow;
	id		keyWindow;
	id		probWindow;
	id		plaidWindow;
	id		statWindow;	
	id		trivWindow;	
	
	id		nblokAve;
	id		nblokLen;
	id		probEI;
	id		probGens;
	id		probFlip;
	id		probGrid;
	id		probHowMany;
	id		probComp;
	id		probLevel;
	id		probView;
	
	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;
}

- loadProb:sender;

- showEProb:sender;
- showNBlock:sender;
- showXBlock:sender;
- showBasin:sender;
- showEntropy:sender;
- showProb:sender;
- showPlaid:sender;
- showStat:sender;

- drawBlock:sender;
- drawNBlock:sender;
- drawProb:sender;
- drawStat:sender;

- printBlock:sender;
- printEntropy:sender;
- printEProb:sender;
- printNBlock:sender;
- printXBlock:sender;
- printProb:sender;
- printPlaid:sender;
- printPlain:sender;
- printStat:sender;

- nxasfreq:sender;
- nxmoncar:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;
@end

/* end ProbView.h */
