
#import "RulePanel.h"
#import "nxlcau3h.h"
#import "rec.h"
#import <string.h>
#import <math.h>
#import <time.h>
#import <stdlib.h>

extern char arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern int  binrule[KK][KK];
extern char ascrule[KK][KK];
extern char auxrule[KK][KK];
extern char gf3rule[13];		/* coefficients of GF3 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern Inst   xprg[][XLEN];
extern struct fptbl dtbl[];
extern char   idef[][WNML];

void    asctobin();
void	asczero();
void	auxzero();
void    clumin(char *c);
int     cyy(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     longwolftoasc(char *c);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    putionj(int i, int j);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p0, double p1, double p2);
void    ranvachrul(char *c);
void    runowows(char x[2][2], int n);
void    rule3h();
void    stzero();
int     svwolftoasc(char arul[KK][KK], char *c);
void	totoasc();
int     totonu(int i);
void    ttzero();
void    wolnum2(char ii[KK][KK], int c);
void    wru(char *c);


void	bincopy(birular *rz, int rx[KK][KK]);		/*prototypes*/
void	binprod(birular *rz, birular rx, birular ry);	/*prototypes*/
void	binsum(birular *rz, birular rx, birular ry);	/*prototypes*/
void	bintoasc();

void    wrru(char *c, char ru[KK][KK]);
void    chrucopy(char ii[KK][KK], char jj[KK][KK], int c);
int     allperm(char wnum[][WNML], char ii[][KK][KK], char ru[KK][KK]);
int     vecperm(int ii[KK], int n);

void	xtoasc(int n);
int     ycc(int i);

int permu[][KK] = {
	{0, 1, 2},
	{0, 2, 1},
	{1, 0, 2},
	{1, 2, 0},
	{2, 0, 1},
	{2, 1, 0}
	};


char    xr[DS] = "121220101";
char    xp[DS] = "642451213";
char    xq[DS] = "135326564";

int  goodCart = NO;
int  frul[2][3][3];
int  clanpair[KK][KK];

@implementation RulePanel

/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
  if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
  if (strcmp(ch,"permuted")==0)    [self loadLowerPanel: permutRuleBox];
  if (strcmp(ch,"Permuted")==0)    [self loadLowerPanel: PermutRuleBox];
  if (strcmp(ch,"clannish")==0)    [self loadLowerPanel: subsetRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox {
  NXRect bxRect, loRect;
  id cv;
cv=[thisRuleBox contentView];
printf("thisRuleBox title = %d\n",[[cv subviews] count]);
  nowSpesh=thisRuleBox;
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=ruleBox;
  if (sender==symWindow)  nowBox=symBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==infoPanel)  nowBox=sender;
  if (sender==designPanel)  nowBox=designBox;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- AllZeroes:sender {int i0, i1;
   for (i0=0; i0<KK; i0++)
       for (i1=0; i1<KK; i1++)
	    {ascrule[i0][i1]='0';}
   auxzero();
   [self setAllRules: self];
   [self setAllImages: self];
   return self;
 }

- protectGenRule:sender {int i, j, k, i0, i1;
  i=j=[sender selectedCol];
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
  k=auxrule[i0][i1];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1]=!k;
return self;
}

- showSymClass:sender {
char ii[RSYM][KK][KK], wnum[RSYM][WNML]; int i, l;
  l=allperm(wnum,ii,ascrule);
  for (i=0; i<RSYM/2; i++) {
	[[symImages cellAt: i: 0] setStringValue: wnum[i]];
	[[symImages cellAt: i: 1] setStringValue: wnum[i+RSYM/2]];
	}
  [symMinimum setStringValue: wnum[l]];
return self;
}

- relatedRule:sender {
char ii[RSYM][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int j, k, l, jj[KK];
  l=allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
       if (strcmp(titl,"reflected")==0) k=6;
  else if (strcmp(titl,"flip")==0)      k=3;
  else if (strcmp(titl,"cycle")==0)     k=1;
  else if (strcmp(titl,"cluster")==0)   k=RSYM;
  else if (strcmp(titl,"least")==0)     k=l;
  else    			      k=0;
  if (k==RSYM) {
    clumin(c);
printf("clumin = %s\n",c);
    svwolftoasc(ascrule,c);
    [self setAllRules: self];
    [self setAllImages: self];
    return self;
    }
  chrucopy(ascrule,ii[k],'w');
  [self setAllRules: self];
  [self setAllImages: self];
  if ([changeLine state]) {
	  l=vecperm(jj,k);
	  for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
	  if (l) {
		for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
		for (j=0; j<AL; j++) arr1[j]=arr2[j];
		 }
	}
// printf ("Related Rules\n");
// for (k=0; k<RSYM; k++) printf("%s\n",wnum[k]);
return self;
}

/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */
int vecperm(ii,n) int ii[KK], n;
{ int i, k, l;
  l=!(n<RSYM/2); k=(l?RSYM/2-6:n);
  switch (k) {
	case 0: for (i=0; i<KK; i++) ii[i]=i; break;
	case 1: for (i=0; i<KK; i++) ii[i]=ycc(i); break;
	case 2: for (i=0; i<KK; i++) ii[i]=cyy(i); break;
	case 3: for (i=0; i<KK; i++) ii[i]=fli(i); break;
	case 4: for (i=0; i<KK; i++) ii[i]=fli(ycc(i)); break;
	case 5: for (i=0; i<KK; i++) ii[i]=fli(cyy(i)); break;
	default: for (i=0; i<KK; i++) ii[i]=i; break;
	     }
return l;
}


/* generate a table of permutations of a given rule       */
/* and report the index of the rule with smallest wru     */
/* wn - array to be filled with 9-letter wolfrang numbers */
/* ii - array to be filled with ascrule symmetry images   */
/* ru - reference KK8KK8KK table - e.g. ascrule           */
/* return value is the index of the least of all these    */
/* that is, wn[...] is the number, ii[...] is the rule    */
int allperm(wnum,ii,ru) char wnum[RSYM][WNML], ii[RSYM][KK][KK], ru[KK][KK];
{ int l, k;

chrucopy(ii[ 0],ru,   'w'); /* identity */
chrucopy(ii[ 1],ru,   'y'); /* (012)    */
chrucopy(ii[ 2],ii[1],'y'); /* (021)    */
chrucopy(ii[ 3],ii[0],'t'); /* (12)     */
chrucopy(ii[ 4],ii[1],'t'); /* (20)     */
chrucopy(ii[ 5],ii[2],'t'); /* (01)     */
chrucopy(ii[ 6],ii[0],'r'); /* reflect  */
chrucopy(ii[ 7],ii[1],'r'); /* (012)r   */
chrucopy(ii[ 8],ii[2],'r'); /* (021)r   */
chrucopy(ii[ 9],ii[3],'r'); /* (12)r    */
chrucopy(ii[10],ii[4],'r'); /* (20)r    */
chrucopy(ii[11],ii[5],'r'); /* (01)r    */
for (k=0, l=0; k<RSYM; k++)
    { wrru(wnum[k],ii[k]); /*calcula el numero de Wolfram*/
      if (strlen(wnum[k]) > strlen(wnum[l])) continue;
      if (strlen(wnum[k]) < strlen(wnum[l])) {l=k; continue;}
      if (strcmp(wnum[k],wnum[l]) < 0) l=k;
    }
return l;
}

/* copy a related (character) rule */
/* c = w - no change  		   */
/* c = y - cyclic permutation      */
/* c = r - reflected		   */
/* c = t - transpose 1&2	   */

void chrucopy(ii,jj,c) char ii[KK][KK], jj[KK][KK]; int c;
{ int i0, i1;
  switch (c) {
     case 'w':
	for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
	    ii[i0][i1]=jj[i0][i1];
	break;
     case 'y':
	for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
	    ii[i0][i1]=ycc(jj[cyy(i0)][cyy(i1)]);
	break;
     case 'r':
	for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
	    ii[i0][i1]=jj[i1][i0];
	break;
     case 't':
	for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
	    ii[i0][i1]=fli(jj[fli(i0)][fli(i1)]);
	break;
     default: break;
             }
}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(binrule,binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/* for 3-state automata use base 9 to decimal that is, 0-9   */
void wru(c) char *c; {int i; 
  i=ascrule[0][0]-'0'+KK*(
    ascrule[0][1]-'0'+KK*(
    ascrule[0][2]-'0'+KK*(
    ascrule[1][0]-'0'+KK*(
    ascrule[1][1]-'0'+KK*(
    ascrule[1][2]-'0'+KK*(
    ascrule[2][0]-'0'+KK*(
    ascrule[2][1]-'0'+KK*(
    ascrule[2][2]-'0'))))))));
  sprintf(c,"%5d",i);
}

/* calculate wru from an argument rule  */
void wrru(c,ru) char *c, ru[KK][KK]; {
int  i;
int  i0;
for (i0=0; i0<KK; i0++)
  {
  i= 9*(ru[i0][2]-'0')
    +3*(ru[i0][1]-'0')
    +  (ru[i0][0]-'0')
    +'0';
  if (i>'9') i=i+('A'-':');
  c[KK-i0-1]=i;
  }
c[KK]=0;
}

/* calculate (3,3/2) wru from an argument rule  */
void wthru(c,ru) char *c, ru[KK][KK][KK][KK]; {
int  i;
int  i0, i1, i2;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++)
  {
  i= 9*(ru[i0][i1][i2][2]-'0')
    +3*(ru[i0][i1][i2][1]-'0')
    +  (ru[i0][i1][i2][0]-'0')
    +'0';
  if (i>'9') i=i+('A'-':');
  c[KK*(KK*(KK-i0)-i1)-i2-1]=i;
  }
c[KK*KK*KK]=0;
}

/* calculate (3,5/2) wru from an argument rule  */
void wfhru(c,ru) char *c, ru[KK][KK][KK][KK][KK][KK]; {
int  i;
int  i0, i1, i2, i3, i4;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {
  i= 9*(ru[i0][i1][i2][i3][i4][2]-'0')
    +3*(ru[i0][i1][i2][i3][i4][1]-'0')
    +  (ru[i0][i1][i2][i3][i4][0]-'0')
    +'0';
  if (i>'9') i=i+('A'-':');
  c[KK*(KK*(KK*(KK*(KK-i0)-i1)-i2)-i3)-i4-1]=i;
  }
c[KK*KK*KK*KK*KK]=0;
}

/* report Wolfram rule number or variant */
void wolnum2(ii,c) char ii[KK][KK], c; {
int k, i0, i1;
  k=0;
  switch (c) {
    case 'w':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      ii[i0][i1]=ascrule[i0][i1];
      break;
    case 'y':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
        ii[i0][i1]=ycc(ascrule[cyy(i0)][cyy(i1)]);
      break;
    case 'r':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
        ii[i0][i1]=ascrule[i1][i0];
      break;
    case 't':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
        ii[i0][i1]=fli(ascrule[fli(i0)][fli(i1)]);
      break;
    default: k=0; break;}
}

int fli(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '2'; 
	case '2': return '1';
	case 0: return 0;
	case 1: return 2; 
	case 2: return 1;
	default:  return '0';}
}

int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '0';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 0;
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '2';
	case '1': return '0'; 
	case '2': return '1';
	case 0: return 2;
	case 1: return 0; 
	case 2: return 1;
	default:  return '0';}
}

- readWRule:sender {char *c;
 c=[sender stringValue];
 if (longwolftoasc(c)) {[self setAllImages: self]; [self setAllRules: self];}
 else [ruleNumber setStringValue: "invalid"];
return self;
}

- readSVRule:sender {char *c;
 c=[sender stringValue];
 if (svwolftoasc(ascrule,c)) 
	{[self setAllRules: self]; [self setAllImages: self];}
 else [ruleNumber setStringValue: "***"];
return self;
}

int longwolftoasc(c) char *c; {int i0, i1;
  int n;
  n=atoi(c);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
   { 
    if (n > 19682) return FALSE;
    ascrule[i0][i1]='0'+n%KK;
    n/=KK;
    }
return TRUE;
}

int  longerwolftoasc(char arul[KK][KK][KK][KK], char *c) {
char d[KK*KK*KK], e;
int  i, l, n, i0, i1, i2;
  l=strlen(c);
  for (i=0; i<KK*KK*KK; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'q') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'Q') n=e-'A'+10;
    else    return FALSE;
    d[KK*KK*KK-l+i]=n;
    }
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    n=d[KK*KK*KK-i0*KK*KK-i1*KK-i2-1];
    arul[i0][i1][i2][0]='0'+n%KK; n/=KK;
    arul[i0][i1][i2][1]='0'+n%KK; n/=KK;
    arul[i0][i1][i2][2]='0'+n%KK;
    }
  return TRUE;
}

int  svwolftoasc(char arul[KK][KK], char *c) {
char d[KK], e;
int  i, l, n, i0;
  l=strlen(c);
  for (i=0; i<KK; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'q') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'Q') n=e-'A'+10;
    else    return FALSE;
    d[KK-l+i]=n;
    }
  for (i0=0; i0<KK; i0++) {
    n=d[KK-i0-1];
    arul[i0][0]='0'+n%KK; n/=KK;
    arul[i0][1]='0'+n%KK; n/=KK;
    arul[i0][2]='0'+n%KK;
    }
  return TRUE;
}

- readSqRule:sender {char ch[WNML]; int i, j;
   for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
	ascrule[i][j] = [[sender cellAt: i: j] intValue] + '0';
   [self setAllRules: self];
   [self setAllImages: self];
   return self;
}

- setRule:sender {char ch[WNML]; int i, ii, j, jj, i0, i1;
   wru(ch);
   [ruleNumber setStringValue: ch];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  [self setAllImages: self];
  return self;
}

- insertRule:sender {
char c[2];
int  i, j, k;
  i=[sender selectedRow];
  j=[sender selectedCol];
  k=[whichState selectedRow]+'0';
  ascrule[i][j]=k;
  c[0]=k; c[1]=0;
  [[sender selectedCell] setTitle: c];
  [self setAllImages: self];
return self;
}

- resetRuButtons:sender {int i0, i1;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    [[ruButtons cellAt: i0: i1] setTitle: ""];
    }
  [self readWRule: ruleNumber];
  [self setAllImages: self];
return self;
}

- setAllImages:sender {int i0, i1;
  asctobin();
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    [[sqascru cellAt: i0: i1] setIntValue: binrule[i0][i1]];
    }
return self;
}

- setAllRules:sender {char ch[WNML]; int i, j, i0, i1;
  wru(ch);
  [ruleNumber setStringValue: ch];
  asctobin();
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
    j=KK*i0+i1;
    for (i=0; i<KK; i++) {
      [[ascru cellAt: i: j] setIntValue: NO];
      if (auxrule[i0][i1]) [[ascru cellAt: i: j] setEnabled: NO];
      if (auxrule[i0][i1]) [[ascru cellAt: i: j] setBordered: NO];
      }
    [[ascru cellAt: binrule[i0][i1]: j] setIntValue: YES];
    }
  wru(ch);
  [ruleNumber setStringValue: ch];
  wrru(ch,ascrule);
  [svrule setStringValue: ch];
  [probView loadProb: self];
   if      (istot()==1) {asctotot(); [self setTotRules: self];}
      else [totlRef setStringValue: " "];
  [self showProbability: pSliders];
return self;
}

- freeAllRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<9; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranRules:sender {
  granrule();
  asctobin();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranPRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

/* generate a random rule */
void granrule() {int i, i0, i1;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) 
	ascrule[i0][i1]=(random()%KK)+'0';
}

/* generate a random protected rule */
void granprule() {int i0, i1;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  if (auxrule[i0][i1]==0) ascrule[i0][i1]=(random()%KK)+'0';
}

- showProbability:sender 
{int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- randomLine:sender
{double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1],p[2]);
return self;
}

- sCellLine:sender {putionj(1,0); return self;}

- uniformLine:sender {ranblin(0.333,0.333,0.333); return self;}

- useRECLine:sender
{ [RECPanel makeKeyAndOrderFront:sender];
  [RECValue setStringValue: "*"];
  return self;
}

- runRECLine:sender; {
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) {
     [RECValue setStringValue: "T"];
     [self setAllRules: self];
     [self setAllImages: self];
     }
  else
    [RECValue setStringValue: "F"];
  return self;
}

/* - - - - - - - -   D E M O N S T R A T I O N   R U L E S  - - - - - - - - */

- setDemo:sender 
{char ch[20];
  wru(ch);
  [ruleNumber setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  [self setAllImages: self];
  return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E   I   - - - - - - - - */

- pmutRule: sender 
{int i, j, p[KK], ru[KK][KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) ru[i][j] = ascrule[p[i]][p[j]]-'0';
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) ascrule[i][j] = p[ru[i][j]]+'0';
  asctobin();
  [self setAllRules:self];
  [self setAllImages: self];
return self;
}

- pmutValue: sender {int i, j, k, p[KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) {
    k = ascrule[i][j] - '0';
    ascrule[i][j] = p[k] + '0';
    }
  asctobin();
  [self setAllRules:self];
  [self setAllImages: self];
return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E   II  - - - - - - - - */

- pmuteRule: sender 
{int i, j;
  asctobin();
  switch ([pRu selectedRow]) {
    case 0: for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
	ascrule[i][j]=cyy(binrule[i][j])+'0'; break;
    case 1: for (i=0; i<KK; i++) for (j=0; j<KK; j++)
	ascrule[i][j]=ycc(binrule[i][j])+'0'; break;
    case 2: for (i=0; i<KK; i++) for (j=0; j<KK; j++)
	ascrule[i][j]=fli(binrule[i][j])+'0'; break;
    case 3: for (i=0; i<KK; i++) for (j=0; j<KK; j++)
	ascrule[i][j]=cyy(fli(binrule[i][j]))+'0'; break;
    case 4: for (i=0; i<KK; i++) for (j=0; j<KK; j++)
	ascrule[i][j]=ycc(fli(binrule[i][j]))+'0'; break;
    default: break;}
  [self setAllRules:self];
return self;
}

- pMutRule: sender 
{
  asctobin();
  ptedbrul(binrule,binrule,[pRu intValue]);
  [self setAllRules:self];
 return self;
}

void ptedbrul(pr,br,k) int pr[KK][KK], br[KK][KK], k; {int i, j; 
for (i=0; i<KK; i++) for (j=0; j<KK; j++) pr[i][j]=permu[k][br[i][j]];}

/* - - - - - - - - - - - - -   G F ( 3 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender 
{int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf3rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender 
{int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf3rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender  {int s;
    s=[sender selectedRow];
    gf3rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF3Rule:sender {
//   int i; for (i=0; i<13; i++) printf("%1d ",gf3rule[i]); printf("\n");
    gftoasc();
    [self setAllRules:self];
    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - - -  S Y M M E T R I C   R U L E  - - - - - - - - - - - */

/* create the rule defined by the "symmetric rule" panel */
- symRule:sender {int i, j, k, i0, i1, r;
  i=[[sRuleCoef selectedCell] tag];
  j=[[sRuleExp  selectedCell] tag];
  k=[[sRuleIncr selectedCell] tag];
// printf("symRule says %2d, %2d, %2d\n",i,j,k);
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
    r=(KK+i0-i1)%KK;
    r=i+j*r*r;
      switch (k) {
        case 0: r+=i0; break;
        case 1: r+=i1; break;
        case 2: r+=(2*KK-i1-i0); break;
        case 3: break;
        default: break;}
    ascrule[i1][i0]=r%KK+'0';
    }
  return self;
  }

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [self setAllImages: self];
    [toWindow setDocEdited:NO];
return self;
}

- readTRule:sender
  {char  *c; int i, j, l, m;
     c=[sender stringValue];
     l=strlen(c); m=YES;
     if(l>TS) {[toRuleNumber setStringValue: "too long"]; return self;}
     for (j=0; j<TS; j++) ttrule[j]='0';
     for (j=0; j<l;  j++) {
       i=c[j];
       if ( i<'0' || i>'2' ) {c[j]='*'; m=NO;}
       }
     if (m) for (j=0; j<l; j++) ttrule[j]=c[j];
       else {[sender display]; return self;}
     totoasc();
     [self setTotRules: self];
     return self;
   }

/* copy ttrule */
void wtrru(c, ru) char *c, ru[TS]; {int  i;
  for (i=0; i<TS; i++) c[i]=ru[i];
  c[TS]=0;
}

- setTotRule:sender {char ch[WNML];
  ttrule[[sender selectedCol]]=[sender selectedRow]+'0';
  [self setTotRules: self];
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toWindow setDocEdited:YES];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  if (istot()==1) {
	[totlRef setStringValue: "totalistic"];
	wtrru(ch,ttrule);
	[toRuleNumber setStringValue: ch];
	}
  else {
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllTotRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroTotRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranTRule:sender {char ch[TS+1]; int i, j, k;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setIntValue: NO];
    k=random()%KK;
    ttrule[j]=k+'0';
    [[toascru cellAt: k: j] setIntValue: YES];
    }
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toRuleNumber selectText: self];
  [toWindow setDocEdited:YES];
return self;
}

- ranPTotRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

/* generate a random protected rule */
void granptotrule() {int i0, i1, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++) {
          if (i%8 == 0) j=random();  i++;
  	      if (auxrule[i0][i1]==0) 
		  ascrule[i0][i1]='0'+j%KK;
  j/=KK;
  }
}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophobic:sender {int i, j;
  for (i=0; i<KK; i++) ascrule[i][i]=i+'0';
  for (i=0; i<KK-1; i++) for (j=i+1; j<KK; j++) 
    switch ([[clanMatrix cellAt: i: j] title][0]) {
    case '0': ascrule[i][j]=i+'0'; ascrule[j][i]=i+'0'; break;
    case '1': ascrule[i][j]=j+'0'; ascrule[j][i]=i+'0'; break;
    case '2': ascrule[i][j]=i+'0'; ascrule[j][i]=j+'0'; break;
    case '3': ascrule[i][j]=j+'0'; ascrule[j][i]=j+'0'; break;
    default: break;}
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- enterPair:sender {char c[2]; 
  c[0] = [clan2h selectedRow]+'0'; c[1]=0;
  [[sender selectedCell] setTitle: c];
return self;
}

- randphobic:sender {char c[2]; int i, j;
  for (i=0; i<KK-1; i++) for (j=i+1; j<KK; j++) {
    c[0] = (random()%4)+'0'; c[1]=0;
    [[clanMatrix cellAt: i: j] setTitle: c];
    }
return self;
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender 
{int k, n, i0, i1;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
id  z;
int i0, i1;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
    [z setIntValue: ascrule[i0][i1]-'0'];
    z=[z nextText];
    }    
return self;
}

- enterDesign:sender {
int i, k, i0, i1;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1]=(k<KK?k:0)+'0';
    auxrule[i0][i1]=(k<KK?1:0);
    }
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

int permut(k,n) int k, n; {
  switch (n) {
    case 0: break;
    case 1: k=(k+1)%KK; break;
    case 2: k=(KK+k-1)%KK; break;
    case 3: if (k==1) k=2; else if (k==2) k=1; break;
    case 4: if (k==2) k=0; else if (k==0) k=2; break;
    case 5: if (k==0) k=1; else if (k==1) k=0; break;
    default: break;}
  return k;
}

/* - - - - - - - - -    E Q U I V A L E N C E   R U L E    - - - - - - - - - */

- equivalence:sender 
{char ru[2][2], iy[2], iz; int i, i0, i1, ix[KK], choi, p;
  runowows(ru,[eqFactor intValue]);
  choi=[eqChoices intValue];
  p=[eqPair selectedRow];
  switch (p) {
    case 0:  ix[0]=0; ix[1]=0; ix[2]=1;
	     iy[0]='0'; iy[1]='1';
	     iz='2'; break;
    case 1:  ix[0]=0; ix[1]=1; ix[2]=0;
	     iy[0]='0'; iy[1]='2';
	     iz='1'; break;
    case 2:  ix[0]=1; ix[1]=0; ix[2]=0;
	     iy[0]='1'; iy[1]='2';
	     iz='0'; break;
    default: printf("unidentified pair\n"); break;}
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
    i=ru[ix[i0]][ix[i1]];
    ascrule[i0][i1]=(i=='0'?iy[choi%2]:iz);
    choi/=2;
    }
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranqul:sender {
  switch ([sender selectedRow]) {
    case 0: [eqFactor setIntValue: random()%16]; break;
    case 1: [eqChoices setIntValue: random()%16]; break;
    default: printf("unidentified random choice\n"); break;}
return self;
}

/* - - - - -  A R I T H M E T I C   C O M B I N A T I O N  - - - - - */

- arithmCombs:sender
{ birular aza, bzb, czc; int i0, i1;
  [self readWRule: [twoRules cellAt: 0: 0]];
  asctobin();
  bincopy(&aza, binrule);
  [self readWRule: [twoRules cellAt: 1: 0]];
  asctobin();
  bincopy(&bzb, binrule);
  switch ([sender selectedRow])
         { case 0: binsum(&czc,aza,bzb); break;
	   case 1: binprod(&czc,aza,bzb); break;
	   default: printf("arithCombs\n"); break;}
  for (i0=0; i0<KK; i0++)
       for (i1=0; i1<KK; i1++)
	 {binrule[i0][i1]=czc.two[i0][i1];}
  [self setAllRules: self];
  [self setAllImages: self];
  return self;
}

- initTwoRules:sender
{ char ch[20];
  granrule();
  wru(ch);
  [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: ch];
  return self;
}

/* copy one binary rule from another */
void bincopy(rz, rx) birular *rz; int rx[KK][KK];
{int i, j; for (i=0; i<KK; i++) for (j=0; j<KK; j++) rz->two[i][j]=rx[i][j];}

/* fill ascrule from binrule */
void bintoasc()
{ int i0, i1;
  for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
		ascrule[i0][i1]=binrule[i0][i1]+'0';
}

/* sum two binary rules mod KK */ 
void binsum(rz, rx, ry) birular *rz, rx, ry;
{ int i, vec[9]={1,3,9,27,81,243,729,2187,6561}, ax1,ax2;
  ax1=ax2=0;
  for (i=0; i<KK*KK; i++){
    ax1+=rx.one[i]*vec[i];
    ax2+=ry.one[i]*vec[i];
  }
  ax1+=ax2;
  for (i=0; i<KK*KK; i++){
	/*rz->one[i]=(rx.one[i]+ry.one[i])%KK;*/
	rz->one[i]=ax1%KK; ax1/=KK;}
}

/* multiply two binary rules mod KK */
void binprod(rz,rx,ry) birular *rz, rx, ry;
{ int i, vec[9]={1,3,9,27,81,243,729,2187,6561}, ax1,ax2;
  ax1=ax2=0;
  for (i=0; i<KK*KK; i++){
    ax1+=rx.one[i]*vec[i];
    ax2+=ry.one[i]*vec[i];
  }
  ax1*=ax2;
  for (i=0; i<KK*KK; i++){
	rz->one[i]=(rx.one[i]*ry.one[i])%KK;
		rz->one[i]=ax1%KK; ax1/=KK;}
}


@end

/* end RulePanel.m */
