
/* nxardn3h.c						*/
/* program for lcau3h option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/

/*  Copyright (C) 1990	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau3h.h"
# include "nxardn3h.h"

extern int    binrule[KK][KK];
extern double stt, sta[][K2+1][K2+1];

# define K1	KK

extern parneih    amat;
extern parneih    bmat;
extern parneih    cmat;
extern parneih    fmat;
extern parneih    gmat;
extern parneih    hmat;
extern parneih    xmat;
extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;

int  h8[HH];

/* edit the Garden of Eden and ancestor calculation */
void edard() {
char c;
int    i, l, ll, m;
int    i0, i1, i2;
int    s0, s1, s2;
int    t0, t1, t2;
double bb, e, f, ff, g, gg;
double ii, ss, h, hh, kay;
double ex, wy, go, gr, gl;
double cave, csig, xave, xsig; 
double cvec[KK][KK];
double xvec[KK][KK];
double rr[3][2], k[4][2];
double stt, sta[5][K2+1][K2+1];
int    a, b, s, t;

asctobin();
zmat(&amat);  djmat(&amat,0);
zmat(&bmat);  djmat(&bmat,1);
zmat(&cmat);  djmat(&cmat,2);
zzmat(&tmat); tensq(&tmat,&amat,&bmat,&cmat);
unmat(&umat);
zmat(&gmat);
zmat(&xmat);
stt=0.0;
l=m=ss=ll=0;
kay=(double)KK;
s0=nzel(&amat);
t0=tsum(&amat);
s1=nzel(&bmat);
t1=tsum(&bmat);
s2=nzel(&cmat);
t2=tsum(&cmat);
 c=0;
  while (0<1) {
  switch (c) {

//    case 'h': histo(amat,bmat,cmat); break;
//    case 'j': rvers(amat,bmat,cmat); break;
    case 'l':
	mmat(&hmat,&gmat,&gmat);
	mmat(&fmat,&hmat,&hmat);
	mmat(&hmat,&fmat,&fmat);
	mmat(&fmat,&gmat,&hmat);
	a=tsum(&hmat);
	b=tsum(&fmat);
	pmat(&gmat,7,4);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
	videocursor(0,4,20); printf("%3d/ %3d",b,a);
	videocursor(0,6,20); printf("  %6.3f",bb);
	break;
    case 'p':
	l=0;
	mtmat(&hmat,&gmat,&gmat);
	gmat=hmat;
	pmat(&gmat,7,4);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,20,0); printf("%4d (%2d) %5d",t,s,l);
	break;
    case 'r': rever(); break;
    case 's':
	videoscroll(1,0,24,39,0,0);
	videocursor(0,1,0);
	if (ss==0) {printf("S required first"); break;}
	  for (i0=0; i0<K2+1; i0++)
	  for (i1=i0; i1<K2+1; i1++)
	    {f=sta[0][i0][i1]; if (f>0.0) {
	    g=sta[1][i0][i1]/f;
	    h=sta[2][i0][i1]/f;
	    e=sqrt(h-g*g);
            printf("%1d%1d %6.1f, %6.3f, %6.2f, %6.3f\n",i0,i1,f,g,h,e);
	    }}
	f=sta[0][3][3]-stt; if (f>0.0) {
	    g=(sta[1][3][3]-3.0*stt)/f;
	    h=(sta[2][3][3]-9.0*stt)/f;
	    e=sqrt(h-g*g);
	    printf("\n");
	    printf("-- %6.1f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
	    }
	printf("tt %6.1f, %6.3f, %6.2f, %6.3f\n",stt,3.0,9.0,0.0);
	break;
    case 'u':			/* variance of eigenvector components	*/
	auua(&xave,&xsig,&ex,&wy,cvec,xvec,&umat);
	videocursor(0,22,0); printf("av%6.3f, va%6.3f",xave,xsig);
	videocursor(0,24,0); printf(" +%6.3f, ..%6.3f",wy,ex);
	break;
    case 'v':			/* variance of column sums 		*/
	avva(&cave,&csig,cvec,&tmat);
	videocursor(0,23,0); printf("av%6.3f, va%6.3f",cave,csig);
	break;
    case 'w':
      videoscroll(1,0,24,39,0,0);
      videocursor(0,1,0);
      if (ss==0) {printf("S required first"); break;}
        for (i0=0; i0<K2+1; i0++)
        for (i1=i0; i1<K2+1; i1++)
	  {f=sta[0][i0][i1]; if (f>0.0) {
	  e=sta[1][i0][i1]/f;
          g=sta[3][i0][i1];
          h=sta[4][i0][i1];
	  ff=((double)(i0*i0+i1*i1+(K2-i0-i1)*(K2-i0-i1)))/9.0;
          printf("%1d%1d  %6.3f, %6.3f, %6.3f, %6.3f\n",i0,i1,g,h,e,ff);
        }}
      break;
    case 'x':
	l=m;
	gmat=xmat;
	pmat(&gmat,7,4);
	s=nzel(&gmat);
	t=tsum(&gmat);
	videocursor(0,13,0); printf("%3d (%1d) %5u",t,s,1);
	break;
    case 'L':
//	cheq(k,gmat);
	videocursor(0,22,0);
	printf("%4.1f,%4.1f,%4.1f,%4.1f",k[0][0],k[1][0],k[2][0],k[3][0]);
//	cubi(rr,k);
	videocursor(0,18,0); printf("%6.3f,%6.3f",rr[0][0],rr[0][1]);
	videocursor(0,19,0); printf("%6.3f,%6.3f",rr[1][0],rr[1][1]);
	videocursor(0,20,0); printf("%6.3f,%6.3f",rr[2][0],rr[2][1]);
	pmat(&gmat,7,4);
	break;
    case 'P':
	ll=0;
	mmtmat(&vmat,&umat,&umat);
	umat=vmat;
	ppmat(&umat,12,0);
	t=ttsum(&umat);
	s=nnzel(&umat);
	videocursor(0,20,36); printf("%2d",ll);
	videocursor(0,22,18); printf("%6d [%4d]        ",t,s);
	videocursor(0,23,20); printf("                   ");
	videocursor(0,24,20); printf("                   ");
	break;
    case 'Q':
	l*=2;
	mmat(&hmat,&gmat,&gmat);
	gmat=hmat;
	pmat(&gmat,7,4);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,13,0); printf("%3d (%1d) %5d",t,s,l);
	break;
    case 'S':
      for (i0=0; i0<5; i0++)
      for (i1=0; i1<K2+1; i1++) for (i2=0; i2<K2+1; i2++) sta[i0][i1][i2]=0.0;
      for (i1=0; i1<K2+1; i1++) for (i2=0; i2<K2+1; i2++) sta[3][i1][i2]=10.0;
      stt=0.0;
      allmo();
      ss=1;
      break;
    case 'T':
	ll++;
	mmmat(&vmat,&tmat,&umat);
	umat=vmat;
	ppmat(&umat,12,0);
	t=ttsum(&umat);
	s=nnzel(&umat);
	ff=f; f=(double)t;
	h=h*kay;
	gg=g; g=f/h;
	videocursor(0,22,20); printf("%5d [%2u] %6.3f  ",t,s,f/ff);
	videocursor(0,23,20); printf("m[2] ratio:%6.3f ",sqrt(f/ff));
	gr=g/gg; gl=log(gr); go=g*exp(-((double)(ll-1))*gl);
	videocursor(0,24,20); printf("%5.3f exp(%6.3fn)",sqrt(go),0.5*gl);
	for (i=0, ii=0.0; i<8; i++, ii+=1.0)
	  {
	  hh=go*exp(ii*gl)-9.0;
	  if (hh<0.0) hh=-hh;
	  videocursor(0,2+i,20); printf("%2d %5.3f",i,sqrt(hh));
	  }
	for (i=8, ii=8.0; i<16; i++, ii+=1.0)
	  {
	  hh=go*exp(ii*gl)-9.0;
	  if (hh<0.0) hh=-hh;
	  videocursor(0,2+i-8,30); printf("%2d %5.3f",i,sqrt(hh));
	  }
	break;
    case 'X':
	l+=m;
	mmat(&hmat,&xmat,&gmat);
	gmat=hmat;
	pmat(&gmat,7,4);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,13,0); printf("%3d (%1d) %5d",t,s,l);
	break;
    case '=': m=l; xmat=gmat; break;
    case '.':
	videoscroll(1,0,24,39,0,0);
	pmat(&amat,1,0);
	pmat(&bmat,1,4);
 	pmat(&cmat,1,8);
	videocursor(0,5,0); printf("a=%1d",t0);
	videocursor(0,5,4); printf("b=%1d",t1);
	videocursor(0,5,8); printf("c=%1d",t2);
	pmat(&gmat,7,4);
	break;
    default: break;
    } /* end switch */
  }   /* end while  */
}

/* calculate the first two moments of all rules */
void allmo() {
int ig, ih, hg[301];
int i, i0, i1, i2, i3, i4, i5, i6, i7, i8;
int t0, t1, t2;
double f, g, ff;
  i=0;
  for (i0=0;  i0<301; i0++)   hg[i0]=0;
  for (i0=0; i0<KK; i0++) {binrule[0][0]=i0;
  for (i1=0; i1<KK; i1++) {binrule[0][1]=i1;
  for (i2=0; i2<KK; i2++) {binrule[0][2]=i2;
  for (i3=0; i3<KK; i3++) {binrule[1][0]=i3;
  for (i4=0; i4<KK; i4++) {binrule[1][1]=i4;
  for (i5=0; i5<KK; i5++) {binrule[1][2]=i5;
  for (i6=0; i6<KK; i6++) {binrule[2][0]=i6;
  for (i7=0; i7<KK; i7++) {binrule[2][1]=i7;
  for (i8=0; i8<KK; i8++) {binrule[2][2]=i8;
    zmat(&amat);  djmat(&amat,0);
    zmat(&bmat);  djmat(&bmat,1);
    zmat(&cmat);  djmat(&cmat,2);
    zzmat(&tmat); tensq(&tmat,&amat,&bmat,&cmat);
    t0=tsum(&amat);
    t1=tsum(&bmat);
    t2=tsum(&cmat);
    if (t0<=t1&&t1<=t2)
      {
      mmmat(&vmat,&tmat,&tmat);
      mmmat(&umat,&tmat,&vmat);
      mmmat(&vmat,&tmat,&umat);
      ff=(double)ttsum(&umat);
      f= (double)ttsum(&vmat);
      g=f/ff;
      ig=(int)(300.0*((g-3.0)/6.0));
      hg[ig]++;
      ih=hg[ig]; if (ih>100) ih=100+ih/10;
//      videodot(199-ih,10+ig,2);
      sta[0][t0][t1]+=1.0;
      sta[1][t0][t1]+=g; sta[2][t0][t1]+=g*g;
      if (sta[3][t0][t1]>=g) sta[3][t0][t1]=g;
      if (sta[4][t0][t1]<=g) sta[4][t0][t1]=g;
      if (g==3.0) stt+=1.0;
//      printf("%5d %6.3f %1d %1d %1d\n",i,g,t0,t1,t2);
      }
    i++;
    }}}}}}}}}
}

/* calculate separated vertices in tensor cube axaxa+bxbxb+cxcxc */
void distinct(ttmat) thrparn *ttmat; {
int i, j, k;
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) for (k=0; k<KK; k++) {
    ttmat->six[0][0][0][i][j][k]=ttmat->six[i][j][k][0][0][0]=
    ttmat->six[0][0][1][i][j][k]=ttmat->six[i][j][k][0][0][1]=
    ttmat->six[0][0][2][i][j][k]=ttmat->six[i][j][k][0][0][2]=

    ttmat->six[0][1][0][i][j][k]=ttmat->six[i][j][k][0][1][0]=
    ttmat->six[0][1][1][i][j][k]=ttmat->six[i][j][k][0][1][1]=
//    ttmat->six[0][1][2][i][j][k]=ttmat->six[i][j][k][0][1][2]=

    ttmat->six[0][2][0][i][j][k]=ttmat->six[i][j][k][0][2][0]=
//    ttmat->six[0][2][1][i][j][k]=ttmat->six[i][j][k][0][2][1]=
    ttmat->six[0][2][2][i][j][k]=ttmat->six[i][j][k][0][2][2]=0;

    ttmat->six[1][0][0][i][j][k]=ttmat->six[i][j][k][1][0][0]=
    ttmat->six[1][0][1][i][j][k]=ttmat->six[i][j][k][1][0][1]=
//    ttmat->six[1][0][2][i][j][k]=ttmat->six[i][j][k][1][0][2]=

    ttmat->six[1][1][0][i][j][k]=ttmat->six[i][j][k][1][1][0]=
    ttmat->six[1][1][1][i][j][k]=ttmat->six[i][j][k][1][1][1]=
    ttmat->six[1][1][2][i][j][k]=ttmat->six[i][j][k][1][1][2]=

//    ttmat->six[1][2][0][i][j][k]=ttmat->six[i][j][k][1][2][0]=
    ttmat->six[1][2][1][i][j][k]=ttmat->six[i][j][k][1][2][1]=
    ttmat->six[1][2][2][i][j][k]=ttmat->six[i][j][k][1][2][2]=0;

    ttmat->six[2][0][0][i][j][k]=ttmat->six[i][j][k][2][0][0]=
//    ttmat->six[2][0][1][i][j][k]=ttmat->six[i][j][k][2][0][1]=
    ttmat->six[2][0][2][i][j][k]=ttmat->six[i][j][k][2][0][2]=

//    ttmat->six[2][1][0][i][j][k]=ttmat->six[i][j][k][2][1][0]=
    ttmat->six[2][1][1][i][j][k]=ttmat->six[i][j][k][2][1][1]=
    ttmat->six[2][1][2][i][j][k]=ttmat->six[i][j][k][2][1][2]=

    ttmat->six[2][2][0][i][j][k]=ttmat->six[i][j][k][2][2][0]=
    ttmat->six[2][2][1][i][j][k]=ttmat->six[i][j][k][2][2][1]=
    ttmat->six[2][2][2][i][j][k]=ttmat->six[i][j][k][2][2][2]=0;

    }
  }

/* calculate tensor cube axaxa+bxbxb+cxcxc */
void tencu(cumat,amat,bmat,cmat) thrparn *cumat; parneih *amat, *bmat, *cmat; {
int i0, i1, i2, i3, i4, i5;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  cumat->six[i0][i1][i2][i3][i4][i5]+=
	amat->two[i0][i3]*amat->two[i1][i4]*amat->two[i2][i5]+
	bmat->two[i0][i3]*bmat->two[i1][i4]*bmat->two[i2][i5]+
	cmat->two[i0][i3]*cmat->two[i1][i4]*cmat->two[i2][i5];
}

/* calculate tensor square axa+bxb+cxc */
void tensq(tmat,amat,bmat,cmat) twoparn *tmat; parneih *amat, *bmat, *cmat; {
int i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  tmat->four[i0][i1][i2][i3]+=amat->two[i0][i2]*amat->two[i1][i3];
  tmat->four[i0][i1][i2][i3]+=bmat->two[i0][i2]*bmat->two[i1][i3];
  tmat->four[i0][i1][i2][i3]+=cmat->two[i0][i2]*cmat->two[i1][i3];
  }
}

/* coefficients of characteristic equation */
void cheq(k,z) double k[4][2]; int z[KK][KK]; {
int t, p, d;
t=z[0][0]+z[1][1]+z[2][2];
p=z[0][0]*z[1][1]-z[0][1]*z[1][0];
p+=z[1][1]*z[2][2]-z[1][2]*z[2][1];
p+=z[2][2]*z[0][0]-z[2][0]*z[0][2];
d=z[0][0]*(z[1][1]*z[2][2]-z[1][2]*z[2][1]);
d+=z[0][1]*(z[1][2]*z[2][0]-z[1][0]*z[2][2]);
d+=z[0][2]*(z[2][1]*z[1][0]-z[1][1]*z[2][0]);
k[0][0]= 1.0;       k[0][1]=0.0;
k[1][0]=-(double)t; k[1][1]=0.0;
k[2][0]= (double)p; k[2][1]=0.0;
k[3][0]=-(double)d; k[3][1]=0.0;
}

void rvers(amat,bmat,cmat) parneih *amat, *bmat, *cmat; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m3[KK][KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
double o, q, r, s, t, u, v, w, kk1, kk2, kk3, kk4, curt(), fort();

kk1=(double)K1;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],&amat);
cymat(&m1[1],&bmat);
cymat(&m1[2],&cmat);
for (i0=0; i0<KK; i0++) t1[i0]=tsum(&m1[i0]);
// videocursor(0,2,0); printf("%3u,%3u,%3u",t1[0],t1[1],t1[2]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
videocursor(0,4,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3d,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
videocursor(0,6,0);
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    printf("%3d,",t3[i0][i1][i2]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(&m4[i0][i1][i2][i3]);
  }
videocursor(0,10,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3d,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

q=r=s=0.0;
for (i=0; i<KK; i++) {t=((double)(t1[i]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk1); videocursor(0,20,0);  printf("%6.2f",t);
t=curt(r/kk1); videocursor(0,20,10); printf("%6.2f",t);
t=fort(q/kk1); videocursor(0,20,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
 {t=((double)(t2[i0][i1]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk2); videocursor(0,21,0);  printf("%6.2f",t);
t=curt(r/kk2); videocursor(0,21,10); printf("%6.2f",t);
t=fort(q/kk2); videocursor(0,21,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=u=sqrt(s/kk3); videocursor(0,22,0);  printf("%6.2f",t);
t=v=curt(r/kk3); videocursor(0,22,10); printf("%6.2f",t);
t=w=fort(q/kk3); videocursor(0,22,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk4); videocursor(0,23,0);  printf("%6.2f",t);
s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("r:%6.2f",s);
t=curt(r/kk4); videocursor(0,23,10); printf("%6.2f",t);
s=1.0; if (v!=0.0) s=t/v;
videocursor(0,24,12); printf("r:%6.2f",s);
t=fort(q/kk4); videocursor(0,23,20); printf("%6.2f",t);
s=1.0; if (w!=0.0) s=t/w;
videocursor(0,24,24); printf("r:%6.2f",s);

}

void histo(amat,bmat,cmat) parneih *amat, *bmat, *cmat; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[HH];
double s, t, kk8;

kk8=(double)K8;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],&amat);
cymat(&m1[1],&bmat);
cymat(&m1[2],&cmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(&xmat,&m4[i0][i1][i2][i3],&m4[i4][i5][i6][i7]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(&xmat);
  }

for (i0=0; i0<HH; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {i=t8[i0][i1][i2][i3][i4][i5][i6][i7]; if (i<HH) h8[i]++;}

po=da=0;
for (i=0; i<HH; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
  videocursor(0,i0+1,13*i1+1);
  printf("%2d %4d %4d",i,h8[i],po);
  }

videocursor(0,22,0);  printf("ttl %4d in %4d pts;",AV*K8,K8);
videocursor(0,23,0);  printf("average: %2d",AV);
videocursor(0,22,23); printf("beyond:%5d,%3d",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:   %6.2f",t);
s=1.0; if (t>1.0) s=exp(log(t)/8.0);
videocursor(0,24,0); printf("relative sigma:   %6.2f",s);

}

double curt(z) double z; {return exp(log(z)/3.0);}

double fort(z) double z; {return exp(log(z)/4.0);}

/* make a list of the reversible rules */

void rever() {
char chb[WNML], chc[WNML];
char chd[28];
char che[244];
char bsqrule[KK][KK], csqrule[KK][KK];
char dsqrule[KK][KK][KK][KK];
char esqrule[KK][KK][KK][KK][KK][KK];
char ii[RSYM][KK][KK], wbnum[RSYM][WNML], wcnum[RSYM][WNML];
int brul[KK][KK], crul[KK][KK], drul[KK][KK][KK][KK];
int erul[KK][KK][KK][KK][KK][KK];
int i0,i1,i2,i3,i4,i5,i6,i7,i8;
int j0,j1,j2,j3,j4,j5;
int k, kk, l, m, mm, nn;
k=l=m=0;
for (i0=0; i0<KK; i0++) {brul[0][0]=i0;
for (i1=0; i1<KK; i1++) {brul[0][1]=i1;
for (i2=0; i2<KK; i2++) {brul[0][2]=i2;
for (i3=0; i3<KK; i3++) {brul[1][0]=i3;
for (i4=0; i4<KK; i4++) {brul[1][1]=i4;
for (i5=0; i5<KK; i5++) {brul[1][2]=i5;
for (i6=0; i6<KK; i6++) {brul[2][0]=i6;
for (i7=0; i7<KK; i7++) {brul[2][1]=i7;
for (i8=0; i8<KK; i8++) {brul[2][2]=i8;  

  if (runiq(crul,brul)) {
	     byntoasc(bsqrule,brul);
	     byntoasc(csqrule,crul);
	     mm=allperm(wbnum,ii,bsqrule);
	     nn=allperm(wcnum,ii,csqrule);
	     wrru(chb,bsqrule);
	     wrru(chc,csqrule);
	     printf("runiq, k = %3d: %s   %s   %s  %s (%3d)\n",
		    ++k,wbnum[mm],chb,chc,wcnum[nn],kk);
	     kk=0;
	     }
  if (suniq(drul,brul)) {
	     byntoasc(bsqrule,brul);
	     bynthtoasc(dsqrule,drul);
	     wrru(chb,bsqrule);
	     wthru(chd,dsqrule);
	     printf("suniq, l = %3d: %s   %s\n",++l,chb,chd);
	     }
/*
 *  if (tuniq(erul,brul)) {
 *	     byntoasc(bsqrule,brul);
 *	     bynfhtoasc(esqrule,erul);
 *	     wrru(chb,bsqrule);
 *	     wfhru(che,esqrule);
 *	     printf("tuniq, m = %3d: %s   %s\n",++m,chb,che);
 *	     }
*/
  }}}}}}}}}     /* end for nest */
}

int runiq(brul,crul) int brul[KK][KK], crul[KK][KK]; {
int a, b;
int i0, i1;
int j0, j1, j2;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) brul[j0][j1]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++) {
  a=crul[j0][j1];
  b=crul[j1][j2];
  if (brul[a][b]==KK) brul[a][b]=j1;
  if (brul[a][b]!=j1) return(0);
  }
return(1);
}

int suniq(drul,brul) int drul[KK][KK][KK][KK], brul[KK][KK]; {
int a, b, e, f;
int j0, j1, j2, j3, j4;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
  drul[j0][j1][j2][j3]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  if (drul[a][b][e][f]==KK) drul[a][b][e][f]=j2;
  if (drul[a][b][e][f]!=j2) return(0);
  }
return(1);
}

int tuniq(erul,brul) int erul[KK][KK][KK][KK][KK][KK], brul[KK][KK]; {
int a, b, e, f, g, h;
int j0, j1, j2, j3, j4, j5, j6;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
  erul[j0][j1][j2][j3][j4][j5]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  g=brul[j4][j5];
  h=brul[j5][j6];
  if (erul[a][b][e][f][g][h]==KK) erul[a][b][e][f][g][h]=j3;
  if (erul[a][b][e][f][g][h]!=j3) return(0);
  }
return(1);
}

/* fill ascrule from binrule */
void byntoasc(as,bi) char as[KK][KK]; int bi[KK][KK]; 
{int i0, i1; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
    as[i0][i1]=bi[i0][i1]+'0';
}

/* fill (3,3/2) ascrule from (3,3/2) binrule */
void bynthtoasc(as,bi) char as[KK][KK][KK][KK]; int bi[KK][KK][KK][KK]; 
{int i0, i1, i2, i3; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
    as[i0][i1][i2][i3]=bi[i0][i1][i2][i3]+'0';
}

/* fill (3,5/2) ascrule from (3,5/2) binrule */
void bynfhtoasc(as,bi) char as[KK][KK][KK][KK][KK][KK];
		        int bi[KK][KK][KK][KK][KK][KK]; 
{int i0, i1, i2, i3, i4, i5; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
  for (i4=0; i4<KK; i4++) 
  for (i5=0; i5<KK; i5++) 
    as[i0][i1][i2][i3][i4][i5]=bi[i0][i1][i2][i3][i4][i5]+'0';
}

/* print matrix */
void pmat(z,i,j) parneih *z; int i, j; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    {videocursor(0,i+i0,j+i1); printf("%1d",z->two[i0][i1]);}
}

/* print matrix */
void ppmat(z,i,j) twoparn *z; int i, j; {
int i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  videocursor(0,i+KK*i0+i1,j);
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%4d",z->four[i0][i1][i2][i3]);
  }
}

///* display K2xK2 matrix */
//void qqmat(z,i,j) twopanr *z, int i, j; {
//int i0, i1, k, l;
//for (i0=0; i0<K4; i0++)
//for (i1=0; i1<K4; i1++)
//  {
//  k=0; l=z->two[i0][i1];
//  if (l==1) k=1;
//  if (l>=2) k=2;
//  if (l>=4) k=3;
//  videodot(i+i0,j+i1,k);
//  }
//}

/* total matrix elements */
int tsum(z) parneih *z; 
{int i, t; for (i=0, t=0; i<K2; i++) t+=z->one[i]; return t;}

/* total matrix elements */
int ttsum(z) twoparn *z; 
{int i, t; for (i=0, t=0; i<K4; i++) t+=z->one[i]; return t;}

/* count nonzero matrix elements */
int nzel(z) parneih *z; 
{int i, t; for (i=0, t=0; i<K2; i++) if (z->one[i]!=0) t++; return t;}

/* count nonzero matrix elements */
int nnzel(z) twoparn *z; 
{int i, t; for (i=0, t=0; i<K4; i++) if (z->one[i]!=0) t++; return t;}

/* calculate row sums */
void rowsum(x,z) int x[KK]; parneih *z; {int i0, j0;
for (i0=0; i0<KK; i0++) {
  x[i0]=0;
  for (j0=0; j0<KK; j0++) x[i0]+=z->two[i0][j0];
  }
}

/* calculate column sums */
void colsum(x,z) int x[KK]; parneih *z; {int i0, j0;
for (j0=0; j0<KK; j0++) {
  x[j0]=0;
  for (i0=0; i0<KK; i0++) x[j0]+=z->two[i0][j0];
  }
}

/* copy one KKxKK matrix from another: z=x */
void cymat(z,x) parneih *z, *x; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->two[i0][i1]=x->two[i0][i1];
}

/* copy one K2xK2 matrix from another: z=x */
void ccymat(z,x) twoparn *z, *x; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z->four[i0][i1][i2][i3]=x->four[i0][i1][i2][i3];
}

/* multiply KKxKK matrices */
void mmat(z,x,y) parneih *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}

/* multiply transpose of first matrix by second */
void mtmat(z,x,y) parneih *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z->two[i0][i2]+=x->two[i1][i0]*y->two[i1][i2];
      }
}

/* multiply K2xK2 matrices */
void mmmat(z,x,y) twoparn *z, *x, *y; {
int i0, i1, i2, i3, i4, i5;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
      {
      z->four[i0][i1][i4][i5]=0;
      for (i2=0; i2<KK; i2++)
      for (i3=0; i3<KK; i3++)
	z->four[i0][i1][i4][i5]+=
	x->four[i0][i1][i2][i3]*y->four[i2][i3][i4][i5];
      }
}

/* multiply K2xK2*K2 matrices */
void mmmmat(z,x,y) thrparn *z, *x, *y; {
int i0, i1, i2;
  for (i0=0; i0<K3; i0++)
  for (i2=0; i2<K3; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K3; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}

/* multiply transpose of first K2xK2 matrix by second */
void mmtmat(z,x,y) twoparn *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<K2; i0++)
    for (i2=0; i2<K2; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K2; i1++) z->two[i0][i2]+=x->two[i1][i0]*y->two[i1][i2];
      }
}

/* generate the de Bruijn fragment evolving to l in matrix z */
void djmat(z,l) int l; parneih *z; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->two[i0][i1]=(binrule[i0][i1]==l)?1:0;
}

/* zero a KKxKK matrix */
void zmat(z) parneih *z; {int i; for (i=0; i<K2; i++) z->one[i]=0;}

/* generate a K2xK2 unit matrix */
void unmat(z) twoparn *z; {
int i0, i1;
  zzmat(z);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->four[i0][i1][i0][i1]=1;
}

/* generate a K2xK2xK2 unit matrix */
void unimat(z) thrparn *z; 
{int i; zzzmat(z); for (i=0; i<K3; i++) z->two[i][i]=1;}

/* zero a K2xK2 matrix */
void zzmat(z) twoparn *z; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z->four[i0][i1][i2][i3]=0;
}

/* zero a K2xK2xK2 matrix */
void zzzmat(z) thrparn *z; {int i; for (i=0; i<K2*K2*K2; i++) z->one[i]=0;}

/* average and variance of eigenvector components */

void auua(ave,var,ex,wy,cve,vec,mat)
 double *ave, *var, *ex, *wy, *cve, *vec;
 twoparn *mat; {
int    i, j;
double a, v, p, q, r, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat->two[j][i];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
for (i=0; i<K2; i++) vec[i]/=a;
a=1.0/kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
for (p=q=r=0.0, i=0; i<K2; i++)
  {
  p+=cve[i]*vec[i];
  q+=cve[i]*cve[i];
  r+=vec[i]*vec[i];
  }
*ave=a;
*var=sqrt(v/kk2);
*ex=0.0; if(q*r>0.0) *ex=p/sqrt(q*r);
*wy=p;
}

/* average and variance of column sums */

void avva(ave,var,vec,mat) double *ave, *var, *vec; twoparn *mat; {
int    i, j;
double a, v, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat->two[i][j];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
a/=kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
*ave=a;
*var=sqrt(v/kk2);
}


/* end  nxardn3h.c */
